Rails.application.routes.draw do

  locales = Site.first.in_use_locales rescue I18n.available_locales
  
  scope "(:locale)", locale: Regexp.new(locales.join("|")) do
   namespace :admin do 
	  get 'olympiamanagements' , to:  'olympiamanagements#index'
	  get 'olympiamanagements/add_school_data' , to:  'olympiamanagements#add_school_data'
	  get 'olympiamanagements/school_data_list' , to:  'olympiamanagements#school_data_list'
	  get 'olympiamanagements/class_setting' , to:  'olympiamanagements#class_setting'
	  get 'olympiamanagements/sign_up_setting' , to:  'olympiamanagements#sign_up_setting'
	  get 'olympiamanagements/export_school_connection_data' , to:  'olympiamanagements#export_school_connection_data'
	  get 'olympiamanagements/export_sign_up_student_data' , to:  'olympiamanagements#export_sign_up_student_data'
	  get 'olympiamanagements/download_scan_file_of_certificate' , to:  'olympiamanagements#download_scan_file_of_certificate'
	  get 'olympiamanagements/import_editing_number_of_school_class' , to:  'olympiamanagements#import_editing_number_of_school_class'
	  post 'olympiamanagements/update_school_data' , to:  'olympiamanagements#update_school_data'
	  patch 'olympiamanagements/update_school_data' , to:  'olympiamanagements#update_school_data'
	  get 'olympiamanagements/update_school_data' , to:  'olympiamanagements#update_school_data'
	  post 'olympiamanagements/update_sign_up_data' , to:  'olympiamanagements#update_sign_up_data'
	  patch 'olympiamanagements/update_sign_up_data' , to:  'olympiamanagements#update_sign_up_data'
	  get 'olympiamanagements/update_sign_up_data' , to:  'olympiamanagements#update_sign_up_data'
	  get 'olympiamanagements/download_import_file' , to:  'olympiamanagements#download_import_file'
      get 'olympiamanagements/sign_up_student_data_list' , to:  'olympiamanagements#sign_up_student_data_list'
	  get 'olympiamanagements/add_sign_up_student_data' , to:  'olympiamanagements#add_sign_up_student_data'
      get 'olympiamanagements/update_student_data' , to:  'olympiamanagements#update_student_data'
      post 'olympiamanagements/update_student_data' , to:  'olympiamanagements#update_student_data'
      patch 'olympiamanagements/update_student_data' , to:  'olympiamanagements#update_student_data'
      resources :olympiamanagements
   end
   resource 'olympiamanagements' do
	get 'update_school_data'
	post 'update_school_data'
	patch 'update_school_data'
	get 'update_student_data'
	post 'update_student_data'
	patch 'update_student_data'
	get 'download_school_code'
	get 'school_connection_data'
	get 'add_sign_up_student_data'
	get 'sign_up_student_data_list'
	get 'edit_password'
	get 'print_registration_form'
	get 'logout'
	post 'login'
  end
  end
end
