require "yaml"
module Olympiamanagement
  class Engine < ::Rails::Engine
    initializer "olympiamanagement" do 
      OrbitApp.registration "Olympiamanagement", :type => "ModuleApp" do
        base_url File.expand_path File.dirname(__FILE__)
        set_keyword_contstraints ['/olympiamanagements/']
        categorizable
        authorizable
        widget_methods ["widget"]
        widget_settings [{"data_count"=>1}]
		frontend_enabled
		side_bar do
          head_label_i18n 'olympiamanagement.olympiamanagement', icon_class: "icons-megaphone"
          available_for "users"
          active_for_controllers (['admin/olympiamanagement'])
          head_link_path "admin_olympiamanagements_school_data_list_path"
          context_link 'olympiamanagement.history_contest',
                                :link_path=>"admin_olympiamanagements_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'index'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.add_school_data',
                                :link_path=>"admin_olympiamanagements_add_school_data_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'add_school_data'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.school_data_list',
                                :link_path=>"admin_olympiamanagements_school_data_list_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'school_data_list'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.class_setting',
                                :link_path=>"admin_olympiamanagements_class_setting_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'class_setting'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.sign_up_setting',
                                :link_path=>"admin_olympiamanagements_sign_up_setting_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'sign_up_setting'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.export_school_connection_data',
                                :link_path=>"admin_olympiamanagements_export_school_connection_data_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'export_school_connection_data'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.export_sign_up_student_data',
                                :link_path=>"admin_olympiamanagements_export_sign_up_student_data_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'export_sign_up_student_data'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.download_scan_file_of_certificate',
                                :link_path=>"admin_olympiamanagements_download_scan_file_of_certificate_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'download_scan_file_of_certificate'},
                                :available_for => 'users'
		  context_link 'olympiamanagement.import_editing_number_of_school_class',
                                :link_path=>"admin_olympiamanagements_import_editing_number_of_school_class_path" ,
                                :priority=>1,
                                :active_for_action=>{'admin/olympiamanagements'=>'import_editing_number_of_school_class'},
                                :available_for => 'users'				
		end
      end
    end
  end
end